package com.lantone.structure.facade.tran;
import com.lantone.common.util.ListUtil;
import com.lantone.structure.model.doc.ClinicalBloodDoc;
import com.lantone.structure.model.entity.Indication;
import com.lantone.structure.model.entity.ResponseType;
import com.lantone.structure.model.label.ClinicalBloodLabel;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2021/2/2 14:16
 */
@Slf4j
public class ClinicalBloodTran extends TargetTran {

    @Override
    public Map<String, String> convert(String text) {
        List<ClinicalBloodDoc> clinicalBloodDocList = new ArrayList<>();
        ClinicalBloodDoc clinicalBloodDoc = new ClinicalBloodDoc();
        clinicalBloodDoc.setText(text);
        clinicalBloodDocList.add(clinicalBloodDoc);
        inputInfo.setClinicalBloodDocs(clinicalBloodDocList);
        aiProcess();
        Map<String, String> structureMap = new HashMap<>();
        bloodContrast(inputInfo.getClinicalBloodDocs(), structureMap);
        return structureMap;
    }

        public void bloodContrast( List<ClinicalBloodDoc> clinicalBloodDocs, Map<String, String> retMap) {
            if(ListUtil.isNotEmpty(clinicalBloodDocs)){
                clinicalBloodDocs.forEach(clinicalBloodDoc -> {
                    int indicationCount = 1;
                    int responseTypeCount = 1;
                    StringBuffer indicationString = new StringBuffer();
                    StringBuffer responseTypeString  = new StringBuffer();
                    ClinicalBloodLabel clinicalBlood = clinicalBloodDoc.getClinicalBloodLabel();

                        if(ListUtil.isNotEmpty(clinicalBlood.getIndication())){
                            for (Indication indications : clinicalBlood.getIndication()) {
                                if(StringUtils.isNotEmpty( indications.getName())){
                                    if(clinicalBlood.getIndication().size()>1){
                                        indicationString.append((indicationCount++) + "." );
                                    }
                                    indicationString.append(indications.getName());
                                }

                            }
                            retMap.put("输血指征",indicationString.toString());
                        }

                    if(clinicalBlood.getType()!= null){
                        if(clinicalBlood.getType().getAmount()!= null && clinicalBlood.getType().getAmount().getMeasurementUnit()!= null &&
                                StringUtils.isNotEmpty(clinicalBlood.getType().getAmount().getMeasurementUnit().getName())){
                            retMap.put("输血量计量单位",clinicalBlood.getType().getAmount().getMeasurementUnit().getName());
                        }
                        if(clinicalBlood.getType().getAmount()!= null &&  StringUtils.isNotEmpty(clinicalBlood.getType().getAmount().getMeasurementUnit().getName())){
                            retMap.put("输血量（mL）",clinicalBlood.getType().getAmount().getName());
                        }
                        if (StringUtils.isNotEmpty(clinicalBlood.getType().getName())){
                            retMap.put("输血类型",clinicalBlood.getType().getName());
                        }

                    }
                    if(clinicalBlood.getReason()!= null && StringUtils.isNotEmpty(clinicalBlood.getReason().getName())){
                        retMap.put("输血原因",clinicalBlood.getReason().getName());
                    }
                    if(clinicalBlood.getStartTime()!= null && StringUtils.isNotEmpty(clinicalBlood.getStartTime().getName())){
                        retMap.put("输血开始时间",clinicalBlood.getStartTime().getName());
                    }
                    if(clinicalBlood.getEndTime()!= null && StringUtils.isNotEmpty(clinicalBlood.getEndTime().getName())){
                        retMap.put("输血结束时间",clinicalBlood.getEndTime().getName());
                    }

                        if (ListUtil.isNotEmpty(clinicalBlood.getResponseType())) {
                            for (ResponseType responseTypes : clinicalBlood.getResponseType()) {
                                if(StringUtils.isNotEmpty( responseTypes.getName())){
                                    if(clinicalBlood.getResponseType().size()>1){
                                        responseTypeString.append((responseTypeCount++) + "." );
                                    }
                                    responseTypeString.append(responseTypes.getNegative().getName() + responseTypes.getName());
                                }
                            }
                            retMap.put("输血反应类型", responseTypeString.toString());
                        }

                });
            }
        }


}